/* Solves the first order ODE from problem 4 using the "bad" second
   order algorithm given in the text. Solution is evolved up to x =
   10.  Note the use of floats rather than doubles to enhance the
   problem. 

   Outputs x and y at each time step; should be redirected to a
   file. */

#define EPS 0.1

#include <stdio.h>
#include <math.h>
#include <stdlib.h>

/* ============================================================= */
float f (float y)
{
  return -y;
}
/* ============================================================= */
int main (int argc, char *argv[])
{
  float x, y, yold, ynew, eps;

  eps = EPS;

  /* Take first step using eq. (3.15) */
  yold = 1.0; 
  y = yold*(1.0L - eps + 0.5L*eps*eps);
  x = eps;
  printf("%f\t%e\n", 0.0, 1.0);

  /* Then do the rest using the bad algorithm.. */
  while (x < 10.0) {
    printf("%f\t% e\n", x, y);
    ynew = yold + 2.0L*eps*f(y);
    yold = y;
    y = ynew;
    x += eps;
  }
  return 0;
}
